#include "io_sync.h"
#include "ai8051u.h"

long _fosc = 22118400L; // ʱӣȷ115200ʣ
long _brt = 115200L;

unsigned char xdata io_sync_buf[12] =
    {0x4C, 0x45, 0x44, 0x28, 0x07, 0x3F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

void set_baud(unsigned int dat) // ѡ, 2: ʹTimer2, ֵ: ʹTimer1.
{
    T2R = 0;   // Timer stop
    T2_CT = 0; // Timer2 set As Timer
    T2x12 = 1; // Timer2 set as 1T mode
    T2H = dat / 256;
    T2L = dat % 256;
    ET2 = 0; // ֹж
    T2R = 1; // Timer run enable
}

void UART1_config(unsigned char brt) // ѡ, 2: ʹTimer2, ֵ: ʹTimer1.
{
    /*********** ʹöʱ2 *****************/
    if (brt == 2)
    {
        S1BRT = 1; // S1 BRT Use Timer2;
        set_baud((unsigned int)(65536UL - (_fosc / 4) / _brt));
    }
    /*********** ʹöʱ1 *****************/
    else
    {
        TR1 = 0;
        S1BRT = 0;     // S1 BRT Use Timer1;
        T1_CT = 0;     // Timer1 set As Timer
        T1x12 = 1;     // Timer1 set as 1T mode
        TMOD &= ~0x30; // Timer1_16bitAutoReload;
        TH1 = (unsigned char)((65536UL - (_fosc / 4) / _brt) / 256);
        TL1 = (unsigned char)((65536UL - (_fosc / 4) / _brt) % 256);
        ET1 = 0; // ֹж
        TR1 = 1;
    }
    /*************************************************/

    SCON = (SCON & 0x3f) | 0x40; // UART1ģʽ, 0x00: ͬλ, 0x40: 8λ,ɱ䲨, 0x80: 9λ,̶, 0xc0: 9λ,ɱ䲨
    //  PS  = 1;    //ȼж
    //  ES  = 1;    //ж
    // REN = 1;    //

    S1_S1 = 0; // UART1 switch to, 00: P3.0 P3.1, 01: P3.6 P3.7, 10: P1.6 P1.7, 11: P4.3 P4.4
    S1_S0 = 0;
}

void DMA_Config(void)
{
    DMA_UR1T_CFG = 0x80; // bit7 1:Enable Interrupt
    DMA_UR1T_STA = 0x00;
    DMA_UR1T_AMT = (12 - 1); // ôֽ(8λ)n+1
    DMA_UR1T_TXAH = (u8)((u16)&io_sync_buf >> 8);
    DMA_UR1T_TXAL = (u8)((u16)&io_sync_buf);
    DMA_UR1_ITVH = 0xff; // ֹϵͳ
    DMA_UR1T_CR = 0xc0;           // bit7 1:ʹ UART1_DMA, bit6 1:ʼ UART1_DMA Զ
}

// IO ͬʼ
//  fosc: ʱƵʣλΪHz
//  brt: ʣλΪHz
//  timer: ѡ, 2: ʹTimer2, ֵ: ʹTimer1.
void sync_io_init(long fosc, long brt, char timer)
{
    EAXFR = 1;
    _fosc = (long)(fosc); // ʱӣȷ㲨ʣ
    _brt = (long)(brt);   // 岨
    UART1_config(timer);  // ѡ, 2: ʹTimer2, ֵ: ʹTimer1.
    DMA_Config();
    EA = 1;
}

void _uart_tx_dma_io_sync(void) interrupt 50
{
    io_sync_buf[0 + 6] = P0;
    io_sync_buf[1 + 6] = P1;
    io_sync_buf[2 + 6] = P2;
    io_sync_buf[3 + 6] = P3;
    io_sync_buf[4 + 6] = P4;
    io_sync_buf[5 + 6] = P5;
    DMA_UR1T_STA = 0x00;
    DMA_UR1T_CR = 0xc0; // ´η
}
